package models

import (
	"time"
)

type PendaftaranSidSem struct {
	ID              string    `gorm:"type:uuid;primaryKey;default:gen_random_uuid()" json:"id"`
	PendaftaranTAID string    `gorm:"type:uuid" json:"pendaftaranTAId"`
	Tipe            string    `json:"tipe"`
	Ditolak         bool      `json:"ditolak"`
	Lulus           bool      `json:"lulus"`
	JudulProposal   string    `json:"judul_proposal"`
	Deskripsi       string    `json:"deskripsi"`
	WaktuMulai      time.Time `gorm:"type:timestamptz" json:"waktuMulai"`
	WaktuSelesai    time.Time `gorm:"type:timestamptz" json:"waktuSelesai"`
	RuanganID       string    `gorm:"type:uuid;null" json:"ruanganId"`
	IdPeriode       string
	Link            string

	Ruangan       Ruangan       `gorm:"foreignKey:RuanganID;references:ID"`
	PendaftaranTA PendaftaranTA `gorm:"foreignKey:PendaftaranTAID;references:ID"`
}

func (PendaftaranSidSem) TableName() string {
	return "pendaftaran_sidsem"
}
