package usecase

import "gitlab.informatika.org/k-01-11/graduit-be/src/module/dashboard_mahasiswa/entity"

type DashboardMahasiswaUseCase interface {
	GetDashboardMahasiswa(IdMahasiswa string) ([]entity.DashboardMahasiswaRet, error)
}

type DashboardMahasiswaUc struct {
	dashboardMahasiswaRepo DashboardMahasiswaRepository
}

func NewDashboardMahasiswaUsecase(dashboardMahasiswaRepo DashboardMahasiswaRepository) *DashboardMahasiswaUc {
	return &DashboardMahasiswaUc{
		dashboardMahasiswaRepo: dashboardMahasiswaRepo,
	}
}

func (uc *DashboardMahasiswaUc) GetDashboardMahasiswa(IdMahasiswa string) ([]entity.DashboardMahasiswaRet, error) {
	newDashboardMahasiswa, err := uc.dashboardMahasiswaRepo.GetDashboardMahasiswaById(IdMahasiswa)

	if err != nil {
		return newDashboardMahasiswa, err
	}

	return newDashboardMahasiswa, nil
}
