package usecase

import (
	"time"

	"gitlab.informatika.org/k-01-11/graduit-be/src/models"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/pendaftaran/entity"
)

type PendaftaranRepository interface {
	NewPendaftaran(pendaftaran models.PendaftaranTA) (output models.PendaftaranTA, err error)
	GetPendaftaran() (output []models.PendaftaranTA, err error)
	DeletePendaftaran(id string) (models.PendaftaranTA, error)
	GetPendaftaranByIdDosen(id string) (output []models.PendaftaranTA, err error)
	SetStatus(id string, val string) (output []models.PendaftaranTA, err error)
	SetTimeInterview(id string, val time.Time) (output []models.PendaftaranTA, err error)
	GetPendaftaranByPeriode(idPeriode string) (output []models.PendaftaranTA, err error)
	GetPendaftaranById(id string) (output []entity.PendaftaranGetResponse, err error)
}
