package repository

import (
	"github.com/google/uuid"
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/pendaftaran_sidsem/entity"
	"gorm.io/gorm"
)

type BerkasSidSemRepo struct {
	DBWrite *gorm.DB
	DBRead  *gorm.DB
}

func NewBerkasSidsemRepository(dbWrite *gorm.DB, dbRead *gorm.DB) *BerkasSidSemRepo {
	return &BerkasSidSemRepo{
		DBWrite: dbWrite,
		DBRead:  dbRead,
	}
}

func (repo *BerkasSidSemRepo) NewBatchBerkas(pendaftaranSidSemId string, berkas []entity.BerkasSidSem) (output []entity.BerkasSidSem, err error) {
	if len(berkas) == 0 {
		return []entity.BerkasSidSem{}, nil
	}

	for i := range berkas {
		berkas[i].ID = uuid.New().String()
		berkas[i].IDPendaftaranSidSem = pendaftaranSidSemId
	}

	result := repo.DBWrite.Create(&berkas)
	if result.Error != nil {
		return nil, result.Error
	}
	return berkas, nil
}

func (repo *BerkasSidSemRepo) GetBerkasByLogID(IDPendaftaranSidSem string) (output []entity.BerkasSidSem, err error) {
	var berkas []entity.BerkasSidSem
	result := repo.DBRead.Where("id_pendaftaran_sidsem = ?", IDPendaftaranSidSem).Find(&berkas)
	if result.Error != nil {
		return nil, result.Error
	}
	return berkas, nil
}
