package usecase

import (
	"gitlab.informatika.org/k-01-11/graduit-be/src/module/ruangan/entity"
	"gitlab.informatika.org/k-01-11/graduit-be/src/utils"
)

type RuanganUsecase interface {
	AddRuangan(ruangan entity.Ruangan) (entity.Ruangan, error)
	GetRuangan(param utils.LimitOffset) ([]entity.Ruangan, error)
	GetRuanganById(id string) (entity.Ruangan, error)
	GetAllRuangan() ([]entity.Ruangan, error)
}

type RuanganUc struct {
	ruanganRepo RuanganRepository
}

func NewRuanganUseCase(ruanganRepo RuanganRepository) *RuanganUc {
	return &RuanganUc{
		ruanganRepo: ruanganRepo,
	}
}

func (uc *RuanganUc) AddRuangan(ruangan entity.Ruangan) (entity.Ruangan, error) {
	newRuangan, err := uc.ruanganRepo.NewRuangan(ruangan)

	if err != nil {
		return newRuangan, err
	}

	return newRuangan, nil

}

func (uc *RuanganUc) GetRuangan(param utils.LimitOffset) ([]entity.Ruangan, error) {
	return uc.ruanganRepo.GetRuangan(param.Limit, param.Offset)
}

func (uc *RuanganUc) GetRuanganById(id string) (entity.Ruangan, error) {
	return uc.ruanganRepo.GetRuanganById(id)
}

func (uc *RuanganUc) GetAllRuangan() ([]entity.Ruangan, error) {
	return uc.ruanganRepo.GetAllRuangan()
}
